{$M 4096,0,4096}
{
Quick program to scrub the heads back and forth over a cleaning disk.
Usage:
cleandrv [drive:]
}

Program cleandrv;

const
  numtracks:byte=40;
  drivenum:byte=0;
  drivechar:char='A';

var
  TicksSinceMidnight:longint ABSOLUTE $0040:$006C;
  w:word;
  s:string;
  c:char;
  p:pointer;
  b:byte;
  curtrack:byte;

Function ReadSectors(drive,head,track,sector,numtoread:byte; buff:pointer):word; assembler;
{drive = 0 for drive A:, 1 = B:, 80h = first hard drive}
asm
        push    ds
        push    bp
        mov     ah,02h
        mov     al,numtoread
        les     bx,buff                 {es:bx -> buffer}
        mov     ch,track
        mov     cl,sector
        mov     dh,head
        mov     dl,drive
        int     13h
        {numsectors read in al, status in ah, cf=0 if successful}
        pop     bp
        pop     ds
end;

Function ResetDrive(drive:byte): Byte; assembler;
{drive = 0 for drive A:, 1 = B:, 80h = first hard drive}
asm
        push    ds
        push    bp
        xor     ax,ax
        mov     dl,drive
        int     13h
        mov     al,ah                   {return status result in al}
        pop     bp
        pop     ds
end;

Function getNumTracks(drive:byte): Byte; assembler;
{drive = 0 for drive A:, 1 = B:, 80h = first hard drive}
asm
        {first, reset the drive}
        push    ds
        push    bp
        xor     ax,ax
        xor     dx,dx
        mov     dl,drive
        push    dx              {save dl=drive}
        int     13h             {reset disk subsystem}
        pop     dx              {restore dl=drive}
        mov     ah,8            {get current drive parameters}
        int     13h
        mov     al,ch           {return number of cylinders in al}
        pop     bp
        pop     ds
end;

procedure trackseek(b:byte);
begin
  ReadSectors(drivenum, 0, b, 1, 1, p);
end;

procedure writebar(n:byte);
var
  b:byte;
begin
  n:=n shr 1;
  for b:=0 to (numtracks shr 1)-1 do
    if b<n
      then write(#176)
      else write(' ');
end;

procedure updateDisp(b:byte);
begin
  if b<10
    then write(#13,'Track: 0',b,' ')
    else write(#13,'Track: ',b,' ');
  {writebar(b);}
end;

procedure wait1sec;
var
  l:longint;
begin
  l:=ticksSinceMidnight;
  repeat until ticksSinceMidnight > l+18;
end;

begin
  writeln('CLEANDRV v0.3.2 - Clean a floppy drive using a cleaning disk');
  if paramcount=0 then begin
    writeln('Usage: CLEANDRV [drive:]');
    halt;
  end;

  getmem(p,512);
  s:=paramstr(1);
  drivechar:=upcase(s[1]);
  drivenum:=ord(drivechar) - ord('A');
  numtracks:=getNumTracks(drivenum) + 1;
  if (numtracks<40)
  or (numtracks>80)
    then numtracks:=40;

  write('Hit <ENTER> to begin cleaning drive ',drivechar,': or CTRL-C to abort:');
  readln;

  ResetDrive(drivenum);
  {seek in butterfly pattern}
  for b:=0 to (numtracks div 2)-1 do begin
    curtrack:=b;
    updateDisp(curtrack);
    trackseek(curtrack);

    curtrack:=numtracks-b-1;
    updateDisp(curtrack);
    trackseek(curtrack);
  end;
  trackseek(numtracks div 2);
  wait1sec;
  for b:=(numtracks div 2)-1 downto 0 do begin
    curtrack:=b;
    updateDisp(curtrack);
    trackseek(curtrack);

    curtrack:=numtracks-b-1;
    updateDisp(curtrack);
    trackseek(curtrack);
  end;
  ResetDrive(drivenum);
  writeln;
end.
