unit d2i_globals;

interface

uses
  objects,
  streams;

const
  CurDrive:byte=1;
  NumSectors:byte=9;
  NumTracks:byte=40;
  NumHeads:byte=2;
  {maxsectors=18;}
  {maxtracks=80;}
  {We define maxsectors/maxtracks as powers of two to speed up array calcs.
  Array goes from ~3k to 8k but saves at least 200,000 cycles per read
  matrix refresh due to no MULs in the loop}
  MaxSectors=32;
  MaxTracks=128;
  MaxHeads=2;
  SectorSize=512;


  DefaultName='output.img';
  IgnoreErrors:boolean=false;           {ignore errors reading geometry}
  IgnoreController:boolean=false;       {ignore controller error status codes}
  ImageSize:longint=0;
  MaxRecoverCount:word=1024;
  MaxTrackSize=maxsectors*maxheads*sectorsize;
  NumErrors:word=0;
  Query:boolean=false;
  Reconstruct:boolean=false;
  RenameExt:boolean=false;
  SecDisplayLineLength=64; {must be multiple of 8!  32, 64 are pretty much only ones}
  SectorCount:word=0;
  SectorsRemaining:word=0;
  StartTick:longint=0;
  TotalSectors:word=0;
  TotalTrackReads:word=0;
  TrackReadCount:word=0;
  TrackSize:word=0;

  {Display constants}
  statusline=24;
  sectorline=0;
  progressline=0;
  screencolumns=80;
  normcolor=$07;
  emphcolor=$09;
  sectcolor=$70;
  salvageSecLine=8;

type
  boot_structure = record
    jmp_instruction     : array[1..3] of byte;
    oem_name            : array[1..8] of char;
    bytes_per_sector    : word;
    sectors_per_cluster : byte;
    reserved_sectors    : word;
    fat_copies          : byte;
    root_entries        : word;
    total_sectors       : word;
    media_descriptor    : byte;
    sectors_per_fat     : word;
    sectors_per_track   : word;
    number_of_heads     : word;
    hidden_sectors      : word;
    total_sector_fixed  : array[1..2] of word;
    drive_number        : byte;
    reserved            : byte;
    ext_boot_sig        : byte;
    serial_number       : array[1..2] of word;
    volume_name         : array[1..11] of char;
    file_system_id      : array[1..8] of char;
    boot_program_code   : array[1..450] of char;
    signature_bytes     : array[1..2] of byte;
  end;
  psector=^tsector;
  tsector=array[0..sectorsize-1] of byte;

  phase=(initial,recovery);

{read matrix display stuff}
type
  secStatus=(good,bad,reconstructed,unknown);
const
  readMatrixIcons:array[0..3] of char=(#250,'!',#168,'?');
  {168 = upside-down '?', #250 = tiny dot}

var
  oldSector:tsector;
  oldSectorp:psector;

  imageName:string;
  imageFile:PBufStream;
  imageTemp:PStream;

  readStatus:array[0..maxTracks-1,0..maxHeads-1,1..maxSectors] of secStatus;
  sectorbuffer,trackbuffer,tempsector:pointer;

implementation

end.
